/*================================================================================================*
 * Данные по протоколу TCP/IP (lip sockets)
 *================================================================================================*/

#ifndef TCPSERVER_DATA_H_
#define TCPSERVER_DATA_H_

#include "global.h"
#include "lip.h"

/*================================================================================================*/
/* Настройки сервера */
#define TCPSERVER_DATA_PORT         11110

/* Настройка буферов */
/* Не делать большими, из-за копирования тормозит алгоритм, а буфер в data.c большой */
#define TCPSERVER_DATA_TX_BUF_SIZE  (8 * 1024)
#define TCPSERVER_DATA_RX_BUF_SIZE  (8 * 1024)

/* Ограничение размера чтения/записи за один вызов функций */
#define TCPSERVER_DATA_MAX_TX_BLOCK (1 * LIP_TCP_MAX_SEND_SIZE)
#define TCPSERVER_DATA_MAX_RX_BLOCK (1 * LIP_TCP_RCV_MSS)

#define TCPSERVER_DATA_BUF_DECL     __attribute__ ((section(".sdram")))
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
/* Инициализация */
void tcpserver_data_init(void);
/*------------------------------------------------------------------------------------------------*/
/* Сброс и повторная инициализация */
void tcpserver_data_reset(void);
/*------------------------------------------------------------------------------------------------*/
/* Вычисление свободного места в буфере передачи (сколько байт можно отправить прямо сейчас) */
size_t tcpserver_data_send_avail(void);
/*------------------------------------------------------------------------------------------------*/
/* Запись данных в буфер передачи */
size_t tcpserver_data_send
    (
    const uint8_t* data,            /* Данные */
    size_t len,                     /* Размер данных в байтах */
    int push                        /* 1 = отправить сразу */
    );                              /* Возвращает количество отправленных байт */
/*------------------------------------------------------------------------------------------------*/
/* Чтение данных из буфера приема */
size_t tcpserver_data_recv
    (
    uint8_t* data,                  /* Буфер для данных */
    size_t len                      /* Размер в байтах (максимальный) */
    );                              /* Возвращает количество прочитанных байт (0..len) */
/*------------------------------------------------------------------------------------------------*/
/* Фоновая функция */
void tcpserver_data_worker(void);
/*------------------------------------------------------------------------------------------------*/
/* Функции управления TCP соединением для данных */
/*------------------------------------------------------------------------------------------------*/
int tcpserver_data_sock_connected_to    /* Проверить, подключен ли к тому же хосту */
    (
    t_lsock_id cmd_sock             /* сокет управляющего соединения, чей remote_ip сравнивается */
    );
/*------------------------------------------------------------------------------------------------*/
void tcpserver_data_sock_listen     /* Слушать новое соединение (если уже есть, закрывается) */
    (
    t_lsock_id cmd_sock             /* сокет управляющего соединения, чей remote_ip слушать */
    );
/*------------------------------------------------------------------------------------------------*/
void tcpserver_data_hangup          /* Закрыть соединение */
    (void);
/*------------------------------------------------------------------------------------------------*/
void tcpserver_data_hangup_on_host  /* Закрыть соединение, если оно с тем же хостом */
    (
    t_lsock_id cmd_sock             /* сокет управляющего соединения, чей remote_ip отключить */
    );
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif /* TCPSERVER_DATA_H_ */
